## libfyaml 0.7.12

=== debian/changelog ===
libfyaml (0.7.12-1) unstable; urgency=medium

  * Update VCS URLs to current valid ones.
  * New upstream version 0.7.12

 -- Jose Luis Blanco Claraco <joseluisblancoc@gmail.com>  Tue, 22 Feb 2022 22:25:26 +0100

libfyaml (0.7.11-2) unstable; urgency=medium

  * Source only upload to enable testing migration.
  * Add myself as uploader.

 -- Timo Röhling <roehling@debian.org>  Fri, 18 Feb 2022 14:04:26 +0100

libfyaml (0.7.11-1) unstable; urgency=medium

  * Initial release. (Closes: #998859)
    Thanks to Pantelis Antoniou for his contribution
    to the packaging.

 -- Jose Luis Blanco Claraco <joseluisblancoc@gmail.com>  Fri, 14 Jan 2022 22:51:33 +0100
