=== debian/rules ===
#!/usr/bin/make -f

# debian builds do not like testsuites to download stuff
%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --disable-network
