=== debian/watch ===
version=4
https://github.com/pantoniou/libfyaml/releases .*/libfyaml-(\d\S*)\.tar\.gz
