## libfyaml 0.8

=== debian/changelog ===
libfyaml (0.8-1build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 11:45:01 +0200

libfyaml (0.8-1) unstable; urgency=medium

  * New upstream version 0.8
  * Add .symbols for public API
  * Add hardening flags to build

 -- Timo Röhling <roehling@debian.org>  Sun, 18 Jun 2023 22:40:15 +0200

libfyaml (0.7.12-2) unstable; urgency=medium

  * Fix d/watch
  * Bump Standards-Version to 4.6.2

 -- Timo Röhling <roehling@debian.org>  Fri, 23 Dec 2022 14:16:49 +0100
