=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: libfyaml
 Priority: optional
-Maintainer: Jose Luis Blanco Claraco <joseluisblancoc@gmail.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Jose Luis Blanco Claraco <joseluisblancoc@gmail.com>
 Uploaders: Timo Röhling <roehling@debian.org>
 Build-Depends: debhelper-compat (= 13),
                pkg-config,
                libltdl-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Section: libs
 Homepage: https://github.com/pantoniou/libfyaml
 Vcs-Git: https://salsa.debian.org/jlblancoc/libfyaml-gbp.git
