## libfyaml 0.9

=== debian/changelog ===
libfyaml (0.9-2) unstable; urgency=medium

  * Link against libatomic where needed
  * Disable build log prettifier (shave)
  * Hide symbols less agressively (causes segfault on mips64el)

 -- Timo Röhling <roehling@debian.org>  Wed, 24 Sep 2025 11:46:02 +0200

libfyaml (0.9-1) unstable; urgency=medium

  * Migrate debian/watch to version 5 format
  * New upstream version 0.9 (Closes: #1107090, #1115982)
  * Wrap and sort Debian package files
  * Bump Standards-Version to 4.7.2
  * Keep exported ABI clean
  * Depend on pkgconf instead of pkg-config
  * Update d/copyright

 -- Timo Röhling <roehling@debian.org>  Mon, 22 Sep 2025 21:33:49 +0200
