=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: libfyaml
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Jose Luis Blanco Claraco <joseluisblancoc@gmail.com>
-Uploaders: Timo Röhling <roehling@debian.org>
-Build-Depends: debhelper-compat (= 13),
-               pkg-config,
-               libltdl-dev
-Standards-Version: 4.6.2
+Maintainer: Jose Luis Blanco Claraco <joseluisblancoc@gmail.com>
+Uploaders:
+ Timo Röhling <roehling@debian.org>,
+Build-Depends:
+ debhelper-compat (= 13),
+ libltdl-dev,
+ pkgconf,
+Standards-Version: 4.7.2
 Section: libs
 Homepage: https://github.com/pantoniou/libfyaml
 Vcs-Git: https://salsa.debian.org/jlblancoc/libfyaml-gbp.git
@@ -16,7 +17,9 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libfyaml0 (= ${binary:Version})
+Depends:
+ libfyaml0 (= ${binary:Version}),
+ ${misc:Depends},
 Description: Fully feature complete YAML parser and emitter (headers)
  Fully feature complete YAML parser and emitter, supporting the latest YAML
  spec and passing the full YAML testsuite.
@@ -29,7 +32,10 @@
 Package: libfyaml-utils
 Section: devel
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, libfyaml0 (= ${binary:Version})
+Depends:
+ libfyaml0 (= ${binary:Version}),
+ ${misc:Depends},
+ ${shlibs:Depends},
 Description: Fully feature complete YAML parser and emitter (CLI tools)
  Fully feature complete YAML parser and emitter, supporting the latest YAML
  spec and passing the full YAML testsuite.
@@ -42,7 +48,9 @@
 Package: libfyaml0
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${shlibs:Depends}, ${misc:Depends}
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
 Description: Fully feature complete YAML parser and emitter (library)
  Fully feature complete YAML parser and emitter, supporting the latest YAML
  spec and passing the full YAML testsuite.
