=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--version-script=$(CURDIR)/debian/libfyaml0.map
ifneq ($(filter armel m68k powerpc sh4,$(DEB_HOST_ARCH)),)
DEB_LDFLAGS_MAINT_APPEND += -latomic
endif

# debian builds do not like testsuites to download stuff
%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --disable-network --disable-shave
