=== debian/watch ===
Version: 5

Template: Github
Owner: pantoniou
Project: libfyaml
