=== debian/changelog ===
libfyaml (0.9.2-1) unstable; urgency=medium

  * New upstream version 0.9.2
  * Bump Standards-Version to 4.7.3
  * Update .symbols file
  * Update d/copyright to reflect licensing change

 -- Timo Röhling <roehling@debian.org>  Fri, 02 Jan 2026 23:50:58 +0100
