## libfyaml 0.9.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -148,6 +148,7 @@
 endif()
 
 # Check for headers and functions
+check_include_file("alloca.h" HAVE_ALLOCA_H)
 check_include_file("byteswap.h" HAVE_BYTESWAP_H)
 check_function_exists(__builtin_bswap16 HAVE___BUILTIN_BSWAP16)
 check_function_exists(__builtin_bswap32 HAVE___BUILTIN_BSWAP32)
@@ -316,4 +317,3 @@
         set(LIBCLANG_INCLUDES "${LLVM_INCLUDE_DIRS};${CLANG_INCLUDE_DIRS}")
         set(LIBCLANG_FOUND TRUE)
         set(LIBCLANG_DETECTION_METHOD "CMake config")
-    elseif(NOT CROSS_COMPILING)
