=== debian/changelog ===
libfyaml (0.9.3-1) unstable; urgency=medium

  * New upstream version 0.9.3
    - Fix abort in in AppStream:as-test_yaml (Closes: #1126193)

 -- Timo Röhling <roehling@debian.org>  Tue, 27 Jan 2026 11:46:11 +0100
