=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  debhelper-compat (= 13),
  libltdl-dev,
  pkgconf,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Section: libs
 Homepage: https://github.com/pantoniou/libfyaml
 Vcs-Git: https://salsa.debian.org/jlblancoc/libfyaml-gbp.git
