## libfyaml 0.9.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.10)
+cmake_minimum_required(VERSION 3.14)
 
 if (POLICY CMP0048)
     cmake_policy(SET CMP0048 NEW) # Allow project(xxx VERSION a.b.c)
@@ -42,6 +42,10 @@
 else()
     set(VERSION_EXTRA "")
 endif()
+
+# Optional MSVC cross-compilation support via msvc-wine
+# Usage: cmake -DMSVC_WINE_DIR=/path/to/msvc [-DMSVC_WINE_COMPILER=cl|clang-cl|clang] ..
+include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/MSVCCrossCompile.cmake OPTIONAL)
 
 project(libfyaml LANGUAGES C ASM VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
 
@@ -85,7 +89,7 @@
         endif()
 
         # Add libclang libraries
-	target_link_libraries(${target_name} ${link_scope} ${LIBCLANG_LIBS})
+        target_link_libraries(${target_name} ${link_scope} ${LIBCLANG_LIBS})
     endif()
 endmacro()
 
@@ -97,7 +101,7 @@
 option(ENABLE_NETWORK "Enable tests requiring network access" ON)
 option(ENABLE_DEVMODE "Enable development mode only debugging" OFF)
 option(BUILD_TESTING "Build tests" ON)
-option(ENABLE_LIBCLANG "Enable libclang support for reflection" ON)
+option(ENABLE_LIBCLANG "Enable libclang support for reflection" OFF)
 
 # Path to LLVM installation (optional, overrides automatic detection)
 set(LLVM_ROOT "" CACHE PATH "Path to LLVM installation directory (e.g., /usr/lib/llvm-15)")
@@ -140,11 +144,21 @@
 endif()
 
 # Check for required dependencies
-set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
-set(THREADS_PREFER_PTHREAD_FLAG TRUE)
-find_package(Threads REQUIRED)
-if(NOT CMAKE_USE_PTHREADS_INIT)
-    message(FATAL_ERROR "Missing required pthread support")
+if(NOT WIN32)
+    set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
+    set(THREADS_PREFER_PTHREAD_FLAG TRUE)
+    find_package(Threads REQUIRED)
+    if(NOT CMAKE_USE_PTHREADS_INIT)
+        message(FATAL_ERROR "Missing required pthread support")
+    endif()
+else()
+    # Windows uses native threading APIs
+    set(CMAKE_USE_WIN32_THREADS_INIT TRUE)
+endif()
+
+# detect if we're on clang-cl
+if(WIN32 AND MSVC AND CMAKE_C_COMPILER_ID STREQUAL "Clang")
+    set(CLANG_CL TRUE)
 endif()
 
 # Check for headers and functions
@@ -162,6 +176,11 @@
     int main() { return 0; }
 " HAVE_DECL_ENVIRON)
 
+# find PkgConfig
+if(NOT CMAKE_CROSSCOMPILING)
+    find_package(PkgConfig)
+endif()
+
 # Check for optional dependencies
 
 # libyaml detection - try CMake config first, then pkg-config
@@ -173,7 +192,6 @@
     set(LIBYAML_LIBRARIES yaml)
     message(STATUS "Found libyaml via CMake config")
 else()
-    find_package(PkgConfig)
     if(PKG_CONFIG_FOUND)
         pkg_check_modules(LIBYAML yaml-0.1)
         if(LIBYAML_FOUND)
@@ -185,10 +203,10 @@
     endif()
 endif()
 
-# check framework detection - try CMake config first, then pkg-config
+# check framework detection - try CMake config first, then pkg-config, then FetchContent
 set(HAVE_CHECK 0)
 set(HAVE_COMPATIBLE_CHECK 0)
-if(BUILD_TESTING)
+if(BUILD_TESTING AND NOT CMAKE_CROSSCOMPILING)
     find_package(check QUIET CONFIG)
     if(check_FOUND)
         set(HAVE_CHECK 1)
@@ -223,7 +241,6 @@
         endif()
     else()
         # Fall back to pkg-config
-        find_package(PkgConfig)
         if(PKG_CONFIG_FOUND)
             pkg_check_modules(CHECK check)
             if(CHECK_FOUND)
@@ -256,6 +273,28 @@
             endif()
         endif()
     endif()
+
+    # Fall back to FetchContent if check not found (useful on Windows)
+    if(NOT HAVE_CHECK)
+        include(FetchContent)
+        message(STATUS "check framework not found, fetching via FetchContent...")
+        FetchContent_Declare(
+            check
+            GIT_REPOSITORY https://github.com/libcheck/check.git
+            GIT_TAG        0.15.2
+        )
+        # Disable check's own tests and docs
+        set(CHECK_ENABLE_TESTS OFF CACHE BOOL "" FORCE)
+        set(CHECK_ENABLE_GCOV OFF CACHE BOOL "" FORCE)
+        FetchContent_MakeAvailable(check)
+
+        set(HAVE_CHECK 1)
+        set(CHECK_LIBRARIES check)
+        set(CHECK_INCLUDE_DIRS "${check_SOURCE_DIR}/src" "${check_BINARY_DIR}" "${check_BINARY_DIR}/src")
+        set(HAVE_SRUNNER_SET_TAP 1)  # 0.15.2 has srunner_set_tap
+        set(HAVE_COMPATIBLE_CHECK 1)
+        message(STATUS "Found check framework via FetchContent")
+    endif()
 endif()
 
 # Check for libclang (for reflection support)
@@ -277,43 +316,3 @@
 
     # If user specified LLVM_ROOT, add it to CMAKE_PREFIX_PATH for this search
     if(LLVM_ROOT)
-        message(STATUS "Using user-specified LLVM_ROOT: ${LLVM_ROOT}")
-        list(PREPEND CMAKE_PREFIX_PATH "${LLVM_ROOT}")
-    endif()
-
-    # Try CMake config mode first
-    find_package(LLVM QUIET CONFIG)
-
-    # If LLVM was found, help CMake find Clang in the same installation
-    if(LLVM_FOUND)
-        # Clang's config is typically in ${LLVM_INSTALL_PREFIX}/lib/cmake/clang
-        set(Clang_DIR "${LLVM_INSTALL_PREFIX}/lib/cmake/clang")
-    endif()
-
-    find_package(Clang QUIET CONFIG)
-
-    if(LLVM_FOUND AND Clang_FOUND)
-
-        message(STATUS "Found LLVM ${LLVM_PACKAGE_VERSION} via CMake config")
-        message(STATUS "  LLVM_INSTALL_PREFIX: ${LLVM_INSTALL_PREFIX}")
-        message(STATUS "  LLVM_INCLUDE_DIRS: ${LLVM_INCLUDE_DIRS}")
-
-        # Use LLVM's CMake variables directly
-        set(LIBCLANG_CFLAGS_LIST ${LLVM_DEFINITIONS})
-        list(APPEND LIBCLANG_CFLAGS_LIST "-I${LLVM_INCLUDE_DIRS}")
-        list(APPEND LIBCLANG_CFLAGS_LIST "-I${CLANG_INCLUDE_DIRS}")
-
-        # Set up library directories
-        set(LIBCLANG_LINK_DIRS ${LLVM_LIBRARY_DIRS})
-
-        # Link against libclang (C API) and LLVM core libs
-        # Need to link against LLVM core for LLVMShutdown() and other LLVM APIs
-        if(TARGET libclang)
-            set(LIBCLANG_LIBS_LIST libclang LLVM)
-        else()
-            set(LIBCLANG_LIBS_LIST clang LLVM)
-        endif()
-
-        set(LIBCLANG_INCLUDES "${LLVM_INCLUDE_DIRS};${CLANG_INCLUDE_DIRS}")
-        set(LIBCLANG_FOUND TRUE)
-        set(LIBCLANG_DETECTION_METHOD "CMake config")
