=== debian/changelog ===
libfyaml (0.9.4-1) unstable; urgency=medium

  * New upstream version 0.9.4
  * Update libfyaml0.symbols

 -- Timo Röhling <roehling@debian.org>  Thu, 12 Feb 2026 18:19:17 +0100
